﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PseudoScope
{
	/// <summary>
	/// Interaction logic for ScopeControl.xaml
	/// </summary>
	public partial class ScopeControl : UserControl
	{
		public List<bool> Trigger = new List<bool>();
		
		public ScopeControl()
		{
			InitializeComponent();
		}

		public void FillTrigger(bool[] data)
		{
			this.Trigger = new List<bool>();
			
			foreach (var b in data)
				this.Trigger.Add(b);

			this.scopeArea.Width = 20 + dX * data.Length;
			
			CreateLine();
		}



		private const int Y2 = 170;
		private const int Y1 = 10;
		private const int dX = 20;

		private void CreateLine()
		{
			this.scopeArea.Children.Clear();

			var x = Y1;	
			var y = Y2;
			var t = 50;

			var line = new Polyline();
			line.Stroke = new SolidColorBrush(Color.FromArgb(0xff, 0x41, 0xFF, 0x27));
			line.StrokeThickness = 1.5;
			line.Points.Add(new Point(0, Y2));

			var tb = new TextBlock();
			tb.FontFamily = new FontFamily("Arial");
			tb.FontSize = 8;
			tb.Text = "[ms]";
			tb.SetValue(Canvas.LeftProperty, (double)2);
			tb.SetValue(Canvas.TopProperty, (double)182);
			this.scopeArea.Children.Add(tb);


			foreach (var b in this.Trigger)
			{
				y = b ? Y1 : Y2;

				line.Points.Add(new Point(x, y));	
				x += dX;
				line.Points.Add(new Point(x, y));

				var l = new Line();
				l.X1 = x;
				l.X2 = x;
				l.Y1 = 5;
				l.Y2 = 195;
				l.Stroke = new SolidColorBrush(Colors.LightSkyBlue);
				l.StrokeThickness = 0.7;
				this.scopeArea.Children.Add(l);


				tb = new TextBlock();
				tb.FontFamily = new FontFamily("Arial");
				tb.FontSize = 8;
				tb.Text = string.Format("{0}", t);
				tb.SetValue(Canvas.LeftProperty, (double)x-10);
				tb.SetValue(Canvas.TopProperty, 0 == t % 100 ? (double)190 : (double)175);

				this.scopeArea.Children.Add(tb);

				t += 50;
			}
	
			this.scopeArea.Children.Add(line);

		}
	}
}
